# coding: utf-8

"""
    Zitadel SDK

    The Zitadel SDK is a convenience wrapper around the Zitadel APIs to assist you in integrating with your Zitadel environment. This SDK enables you to handle resources, settings, and configurations within the Zitadel platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OIDCServiceDeviceAuthorizationRequest(BaseModel):
    """
    OIDCServiceDeviceAuthorizationRequest
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the device authorization request to be used for authorizing or denying the request.")
    client_id: Optional[StrictStr] = Field(default=None, description="The client_id of the application that initiated the device authorization request.", alias="clientId")
    scope: Optional[List[StrictStr]] = Field(default=None, description="The scopes requested by the application.")
    app_name: Optional[StrictStr] = Field(default=None, description="Name of the client application.", alias="appName")
    project_name: Optional[StrictStr] = Field(default=None, description="Name of the project the client application is part of.", alias="projectName")
    __properties: ClassVar[List[str]] = ["id", "clientId", "scope", "appName", "projectName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OIDCServiceDeviceAuthorizationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OIDCServiceDeviceAuthorizationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "clientId": obj.get("clientId"),
            "scope": obj.get("scope"),
            "appName": obj.get("appName"),
            "projectName": obj.get("projectName")
        })
        return _obj


